#include <albro1\enviromentecosystem\Environment\Environment.dme>


turf
{
	var
	{
		original_icon = 'grass.dmi'
	}
	icon = 'grass.dmi';
	New()
	{
		..();
		spawn(20)
		{
			icon = original_icon;
		}
	}

	Entered(o)
	{
		..(o);
		if(ismob(o))
		{
			var mob/m = o
			enviro_UpdateTurf(m.dir);
		}
	}

	proc
	{
		enviro_UpdateTurf(d)
		{
			set background = TRUE

			var amount;


			amount = walked_on;

			var X = 0;
			var Y = 0;
			var chance = prob(5); // 5% chance to do a large rand()

			var icon/temp;
			var icon/T;
			for(var/i = 1, i <= amount, i++)
			{
				while(!X || !Y)
				{
					switch(d)
					{
						if(EAST)
						{
							if(chance)
							{
								X = rand(1, 32);
								Y = rand(1,32);
							}

							else
							{
								X = rand(10, 23);
								Y = rand(1, 32);
							}
						}

						if(WEST)
						{
							if(chance)
							{
								X = rand(1, 32);
								Y = rand(1,32);
							}

							else
							{
								X = rand(10, 23);
								Y = rand(1, 32);
							}
						}

						if(SOUTH)
						{
							if(chance)
							{
								X = rand(1, 32);
								Y = rand(1, 32);
							}

							else
							{
								X = rand(1, 32);
								Y = rand(10, 23);
							}
						}

						if(NORTH)
						{
							if(chance)
							{
								X = rand(1, 32);
								Y = rand(1, 32);
							}

							else
							{
								X = rand(1, 32);
								Y = rand(10, 23);
							}
						}
					}
				}
				T = icon(icon);
				temp = icon('dirt.dmi');
				temp.Shift(NORTH, X, 1);
				temp.Shift(EAST, Y, 1);
				T.Blend(temp, ICON_OVERLAY);
			}
			icon = T;
		}
	}
}

mob
{
	Login()
	{
		..();
		loc = locate(5,5,1);
		src<< "Welcome to my Dynamic Wear demo.  This uses my Environment / Ecosystem Library, and it demonstrates a small example of what you can do with it."
		src<< " "
		src<< "You can see what happens in the demo by walking around on the grass for a bit.  You will see the grass appear to \"wear down\"."
		src<< "Not only does it \"wear down\", it wears down in a pattern according to the direction you walk on it."
		src<< " "
		src<< "<small><b>This is a demo, not a plugin.  This may work if you copy and paste, but it is not made as well as it could be.</b></small>"
		src<< "<small><b>This means that you will have to use this <i>demo</i> as an example to see what is possible with the library.  Create an adaptation yourself.</b></small>"
	}
}


mob
{
	icon = 'mob.dmi';
}